#ifndef pthread0_included
#define pthread0_included


    /* gc doc tells us to include pthread.h before gc.h */
    #ifdef GC_MALLOC
      #error "gc.h already included"
    #endif
    #ifndef _REENTRANT
      #define _REENTRANT
    #endif
    #include <pthread.h>
    #define GC_THREADS
    #include <gc/gc.h>
    #include <../system/mutex.h>


/* included from ../../../../Macaulay2/c/scc1.c*/

#ifdef __cplusplus
  #define BASECLASS : public our_new_delete
  #include "newdelete.hpp"
#else
  #define BASECLASS
#endif

#if defined(__cplusplus)
  extern "C" {
#endif

#ifndef SAFEC_EXPORTS
#define SAFEC_EXPORTS
#endif
#ifndef SAFEC_basic_typedefs_defined
#define SAFEC_basic_typedefs_defined
typedef char M2_bool;
struct tagged_union { unsigned short type_; };
#undef M2_basic_typedefs_defined
#endif

/* typedefs */
typedef void * pthread0_voidPointer;
typedef struct ThreadTask * pthread0_taskPointer;
typedef pthread_mutex_t pthread0_ThreadMutex;
typedef pthread_attr_t pthread0_ThreadAttr;
typedef pthread_mutexattr_t pthread0_ThreadMutexAttr;
typedef pthread_cond_t pthread0_ThreadCond;
typedef pthread_condattr_t pthread0_ThreadCondAttr;
typedef pthread_key_t pthread0_ThreadKey;
typedef pthread_once_t pthread0_ThreadOnce;
typedef pthread_rwlock_t pthread0_ThreadRWLock;
typedef pthread_rwlockattr_t pthread0_ThreadRWLockAttr;
typedef struct spinlockStructure pthread0_SpinLock;
/* array types */
/* struct types */
/* basic types */
typedef void * (*pthread0_threadFunction)(void *);
/* functions */
extern void pthread0__prepare() __attribute__ ((constructor));
extern struct spinlockStructure pthread0_uninitializedSpinLock;
extern pthread_mutex_t pthread0_newMutex;

#if defined(__cplusplus)
  }
#endif

#endif
